#include "LecteurRedacteur.hpp"
#include <ostream>
#include <sstream>

using namespace std;

LecteurRedacteur::LecteurRedacteur() :
  nb_lecteur(0), nb_redacteur(0),
  mut(), mut_ordre(),
  cond_lecteur(), cond_redacteur()
{
}


LecteurRedacteur::~LecteurRedacteur() {
}

void
LecteurRedacteur::DebutLecture() {
  mut_ordre.lock();
  mut.lock();
  while(nb_redacteur>0) {
    cond_lecteur.wait(mut);
  }
  nb_lecteur++;
  mut.unlock();
  mut_ordre.unlock();
}


void
LecteurRedacteur::FinLecture() {
  mut.lock();
  nb_lecteur--;
  if (nb_lecteur == 0) {
    cond_redacteur.notify_one();
  }
  mut.unlock();
}

void
LecteurRedacteur::DebutRedaction() {
  mut_ordre.lock();
  mut.lock();
  while((nb_redacteur>0)||(nb_lecteur>0)) {
    cond_redacteur.wait(mut);
  }
  nb_redacteur++;
  mut.unlock();
  mut_ordre.unlock();
}

void
LecteurRedacteur::FinRedaction() {
  mut.lock();
  cond_redacteur.notify_one();
  cond_lecteur.notify_all();
  nb_redacteur--;
  mut.unlock();
}

ostream& operator<<(ostream &out, const LecteurRedacteur& lr) {
  ostringstream c;
  c << "nblect=" << lr.nb_lecteur << "\tnbred=" << lr.nb_redacteur;

  out << c.str();
  return out;
}
