#pragma once

#include<iostream>
#include <mutex>
#include <condition_variable>
#include <ostream>

class LecteurRedacteur {
  int nb_lecteur;
  int nb_redacteur;
  std::mutex mut;
  std::mutex mut_ordre;
  std::condition_variable_any cond_lecteur;
  std::condition_variable_any cond_redacteur;

public:
  /// constructeur
  LecteurRedacteur();

  /// destructeur
  ~LecteurRedacteur();

  /// Début pour les lecteur
  void DebutLecture();

  /// Fin des lecteur
  void FinLecture();

  /// Début écrivain
  void DebutRedaction();

  /// Fin écrivain
  void FinRedaction();

  // affichage poue des vérification
  friend std::ostream& operator<<(std::ostream &out, const LecteurRedacteur& lr);

private:
  // constructeur par recopie annulé pour éviter les copie de mutex
  LecteurRedacteur(const LecteurRedacteur &lr) = delete;

  // operateur d'affectation supprimé pour éviter les recopie de mutex
  LecteurRedacteur &operator=(const LecteurRedacteur &lr) = delete;
};
