#include "LecteurRedacteur.hpp"

#include <vector>
#include <string>
#include <sstream>
#include <iostream>
#include <ostream>
#include <cmath>
#include <unistd.h>
#include <thread>

using namespace std;

// pour le lr on passe un pointeur ce qui évite les copies d'objets
void lecteur(int num, int nbt, unsigned int seed, LecteurRedacteur *lr) {
  int i;
  ostringstream out;

  out << "seed=" << seed << "\t &seed=" << &seed << endl;
  cout << out.str();
  out.str("");
  
  usleep(1000000);

  for (i=0;i<nbt; i++) {
    lr->DebutLecture();
    out << "lecteur \tnum " << num << " \ttour " << i << "\t:  en section critique " << *lr << endl;

    cout << out.str();
    out.str("");

    usleep((int) ceil(rand_r(&seed)*100.0/RAND_MAX*1.0));
    lr->FinLecture();
    usleep((int) ceil(rand_r(&seed)*100.0/RAND_MAX*1.0));    
  }
  out << "lecteur \tnum " << num << " \ttour " << i << "\t:  J'ai terminé" << endl;
  cout << out.str();
  out.str("");
  
}

void redacteur(int num, int nbt, unsigned int seed, LecteurRedacteur *lr) {
  int i;
  ostringstream out;
  
  out.str("");
  out << "seed=" << seed << "\t &seed=" << &seed << endl;
  cout << out.str();

  usleep(1000000);
  
  for (i=0;i<nbt; i++) {
    lr->DebutRedaction();
    out.str("");
    out << "rédacteur \tnum " << num << " \ttour " << i << "\t:  en section critique " << *lr << endl;
    cout << out.str();

    usleep((int) ceil(rand_r(&seed)*10000.0/RAND_MAX*1.0));
    lr->FinRedaction();
    usleep((int) ceil(rand_r(&seed)*10000.0/RAND_MAX*1.0));    
  }
  out.str("");
  out << "rédacteur \tnum " << num << " \ttour " << i << "\t:  J'ai terminé" << endl;
  cout << out.str();
  
}

int main(int argc, char* argv[]) {
  int nbl, nbr, nbt, i;
  ostringstream out;
  
  if (
      (argc != 4)
      || ((nbl=atoi(argv[1]))==0)
      || ((nbr=atoi(argv[2]))==0)
      || ((nbt=atoi(argv[3]))==0)
      )
    {
      cerr << "usage " << argv[0] << " <nblect> <nbred> <nbtours>" << endl;
      exit(1);
    }

  vector<thread> tabth;
  LecteurRedacteur lr;
  unsigned int seed_general = time(NULL);
  
  
  for (i=0; i<nbr; i++) {
    out << "principal lancement redacteur " << i << endl;
    cout << out.str();
    out.str("");

    unsigned int seed = rand_r(&seed_general);
    tabth.push_back(thread(redacteur, i, nbt, seed, &lr));
  }
  
  for (i=0; i<nbl; i++) {
    out << "principal lancement lecteur " << i << endl;
    cout << out.str();
    out.str("");

    unsigned int seed = rand_r(&seed_general);
    tabth.push_back(thread(lecteur, i, nbt, seed, &lr));
  }
  
  out << "fin de lancement " << endl;
  cout << out.str();
  out.str("");

  i = 0;
  for (auto &th : tabth) {
    th.join();
    out << "principale join de " << i++ << endl;
    cout << out.str();
    out.str("");
    
  }
  
  return 0;
}
